%Run addPaths before using this example

%Here we show again how one can get an implemented GSIP problem. In this
%example we consider only the case where a problem is directly formulated
%as a GSIP. There is also an example for getting a design-centering problem
%given a design and a container. Moreover, there is a example for getting
%a portfolio optimization problem given a uncertainty set.

%First we choose an example where no extra information is needed. We want
%to load Problem1

disp('Load Problem1')
p=Problem1

%the variable p now contains an instance of Problem1. We can now evaluate
%several functions and read out informations describing the problem.

disp('evaluate objective function')

fval=p.evalObjFun([0,1])

disp('evaluate a semi-infinite constraint')
g=p.evalSemiInfConstrs(1,[0,1],2)

disp('evaluate all lower level constraint')
u=p.evalAllLowLevConstrs(1,[0,1],2)

disp('read out the number of lower level constraints')
ILL=p.getNrAllLowLevConstrs(1)

%The inputs and outputs of the functions are described in the documentation

%It is possible that some parameters can be chosen for a problem. To load
%such a problem these parameters need to be specified.

p=Problem8(10)