function [DxDxu] = DxDxAllLowLevConstrs(obj,index,x,y)
    %DxDxu=DxDxAllLowLevConstrs(i,x,y) returns the seccond derivative of the
    %function evalAllLowLevConstrs with respect to x. 

    DxDxu=zeros(0,obj.nrOfUppLevVars,obj.nrOfUppLevVars);
    if obj.nrOfLowLevNonlinConstrs(index)>0
        DxDxu=obj.DxDxLowLevNonlinConstrs(index,x,y);
    end
    
    %Add the linear constraints    
    [A,b]=obj.getLinIneqsOnLowLevVars(index,x);
    [DxDxA,DxDxb]=obj.DxDxLinIneqsOnLowLevVars(index,x);
    nrLinIneqs=size(A,1);
    %Matrix for the indices (linear Indexing)
    indexMatrixb=reshape((0:obj.nrOfUppLevVars^2-1)*nrLinIneqs,...
        obj.nrOfUppLevVars,obj.nrOfUppLevVars)';
    indexMatrixA=reshape((0:obj.nrOfUppLevVars^2-1)*obj.nrOfLowLevVars*nrLinIneqs,...
        obj.nrOfUppLevVars,obj.nrOfUppLevVars)';
    for k=1:nrLinIneqs
        DxDxu_tmp=zeros(obj.nrOfLowLevVars);
        for k1=1:obj.nrOfLowLevVars
            DxDxu_tmp=DxDxu_tmp+DxDxA(indexMatrixA+(k-1)*obj.nrOfLowLevVars+k1)*y(k1);
        end
        DxDxu_tmp=DxDxu_tmp-DxDxb(indexMatrixb+k); 
        DxDxu_tmp=reshape(DxDxu_tmp,[1,size(DxDxu_tmp)]);
        DxDxu=[DxDxu;DxDxu_tmp];
    end
    
    %Add the boundaries
    %Matrix for the indices (linear Indexing)
    indexMatrix=reshape((0:obj.nrOfUppLevVars^2-1)*obj.nrOfUppLevVars,...
        obj.nrOfUppLevVars,obj.nrOfUppLevVars)';
    [lb,ub]=obj.getBoundsOnLowLevVars(index,x);
    [DxDxlb,DxDxub]=obj.DxDxBoundsOnLowLevVars(index,x);
    constrlb=lb-y;
    %drop the boundaries with -inf
    IndicesConstrs=1:obj.nrOfLowLevVars;
    constrlb=IndicesConstrs(constrlb~=-inf);
    
    DxDxu=[DxDxu;DxDxlb(constrlb,:,:)];


    
    construb=y-ub;
    %drop the boundaries with -inf
    IndicesConstrs=1:obj.nrOfLowLevVars;
    construb=IndicesConstrs(construb~=-inf);
    DxDxu=[DxDxu;-DxDxub(construb,:,:)];
    
    


end

