function [ Dyu] = DyAllLowLevConstrs(obj,indexSet,x,y)
    %Dyu=DyAllLowLevConstrs(i,x,y) returns the derivative of the function
    %evalAllLowLevConstrs with respect to y. 

    Dyu=zeros(0,obj.nrOfLowLevVars);
    %Add the non linear constraints
    if obj.nrOfLowLevNonlinConstrs(indexSet)>0
        Dyu=[Dyu;obj.DyLowLevNonlinConstrs(indexSet,x,y)];
    end

    %Add the linear constraints    
    [A,b]=obj.getLinIneqsOnLowLevVars(indexSet,x);
    Dyu=[Dyu;A];
    
    %Add the boundaries
    [lb,ub]=obj.getBoundsOnLowLevVars(indexSet,x);
    constrlb=lb-y;
    %drop the boundaries with -inf
    constrlb=constrlb(constrlb~=-inf);
    Dconstrlb=-eye(obj.nrOfLowLevVars);
    Dconstrlb=Dconstrlb(constrlb~=-inf,:);
    Dyu=[Dyu;Dconstrlb];
   
    construb=y-ub;
    construb=construb(construb~=-inf);
    Dconstrub=eye(obj.nrOfLowLevVars);
    Dconstrub=Dconstrub(construb~=-inf,:);
    Dyu=[Dyu;Dconstrub];

end

