classdef ContainerTriangle < Container
    %C=ContainerTriangle() creates an instance of the container C given by:
    %
    %       C={ y in R^2 with:
    %               -y1-1<= 0
    %               -y1-1 <= 0
    %               0.25y1+y2-0.75 <= 0
    %
    %   Bounding box: [-1,7]x[-1,1]
     
    
    properties (GetAccess=protected)
        dim =2;
        nrOfConstFuns=3;
        BoundingBox=[-1,-1;7,1];
        canPlot='on';
        containerPlot;
        
    end
    

    
    methods
        %Container functions
        function g=evalDescrFuns(obj,i,y)
           
           m=size(y,1);
           o=ones(m,1);
           
       
           switch i
               case 1
                   g=(-y(:,1)-o);
               case 2
                   g=(-y(:,2)-o);
               case 3
                   g=(1/4.*y(:,1)+y(:,2)-3/4.*o);
               otherwise
                  
           end

           
           
        end
        %derivative
        function Dy_g=DyDescrFuns(~,i,y)
            m=size(y,1);
            
            o=ones(m,1);
            z=zeros(m,1);
            switch i
                case 1
                    Dy_g=[-o,z];
                case 2
                    Dy_g=[z,-o];
                case 3
                    Dy_g=[1/4*o,o];
            end
            
        end
    end
    
    methods
        function plotContainer(obj)
            X = [7; ... %vertex
                -1; ... %vertex
                -1]; %vertex
            Y = [-1; ...        %vertex
                -1;... %vertex
                1];     %vertex
   
            ph = fill(X, Y, [135/255, 206/255, 250/255]); % sky blue
            set(ph, 'EdgeColor', 'blue');
            hold on;
        end
    end    
    
end

